#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from .interfaces import IContentPortletSettings
from pyams_portal.interfaces import IPortletRenderer, IPortalContext
from pyams_skin.layer import IPyAMSLayer
from pyams_utils.interfaces import VIEW_PERMISSION

# import packages
from pyams_portal.portlet import PortletSettings, Portlet, PortletRenderer, portlet_config
from pyams_template.template import template_config
from pyams_utils.adapter import adapter_config
from zope.interface import implementer, Interface

from pyams_portal import _


CONTENT_PORTLET_NAME = 'pyams_portal.portlet.content'


@implementer(IContentPortletSettings)
class ContentPortletSettings(PortletSettings):
    """Content portlet persistent settings"""


@portlet_config(permission=VIEW_PERMISSION)
class ContentPortlet(Portlet):
    """Content portlet"""

    name = CONTENT_PORTLET_NAME
    label = _("Context content")

    settings_class = ContentPortletSettings


@adapter_config(context=(IPortalContext, IPyAMSLayer, Interface, ContentPortlet), provides=IPortletRenderer)
@template_config(template='content.pt', layer=IPyAMSLayer)
class ContentPortletRenderer(PortletRenderer):
    """Content portlet renderer"""
